var Page = (function () {
    var instance;

    function createInstance() {
        var welcome = "<strong id='welcome'>Debug log (click to show):</strong><br>";
        var logtext = "";
        var executeJS = "<button onclick=eval(document.getElementById('executeJS').value)>Execute</button><br/><textarea id=executeJS rows=5 cols=60></textarea><br/>";
        var logger = document.getElementById("logger");
        if (logger !== null) {
            var height = '10px';
            logger.style.cursor = 'default';
            logger.style.height = height;
            logger.addEventListener('click', function (e) {
                e = e || window.event;
                if (e.target.id != 'welcome')
                    return;
                this.style.height = this.style.height == 'auto' ? height : 'auto';
                logger.innerHTML = welcome + (this.style.height == 'auto' ? executeJS+logtext : '');
            });
        }
        return {
            log: function (message, br) {
                if (this.isTemplate())
                    console.log(message);
                else {
                    if (logger !== null) {
                        logtext = message + (br != false ? "<br/>" : "") + logtext;
                        logger.innerHTML = welcome + (logger.style.height == 'auto' ? executeJS+logtext : '');
                    }
                }
            },
            logExecution: function (time) {
                this.log('<div style="background: lightgray;">Execution time: ' + time + 's</div>', false);
            },
            isTemplate: function () {
                return document.getElementById("template") !== null;
            },
            showImage: function (id, visible) {
                var img = document.getElementById(id);
                if (img !== null)
                    img.style.visibility = visible == false ? "hidden" : "visible";
            }
        };
    }

    return {
        get: function () {
            if (!instance) {
                instance = createInstance();
            }
            return instance;
        }
    };
})();
